Subject: Re: questions on NAPI processing latency and dropped network packets

From: Eric Dumazet <[email-masked]>
Date: Mon, 21 Jan 2008 22:31:09 +0100

Chris Friesen a écrit :
> I've done some further digging, and it appears that one of the problems 
> we may be facing is very high instantaneous traffic rates.
> 
> Instrumentation showed up to 222K packets/sec for short periods (at 
> least 1.1 ms, possibly longer), although the long-term average is down 
> around 14-16K packets/sec.

Instrumentation done where exactly ?

tcpdump on the host will lie, since timestamps are probably going to be host 
timestamps, giving the time of RX dequeing, and not time of packets arrival 
given by NIC.

> 
> If I bump the rx ring size up to 4096, we can handle all the packets and 
> we still have 44% idle on cpu0 and 27% idle on cpu1.
> 
> Is there anything else we can do to minimize the latency of network 
> packet processing and avoid having to crank the rx ring size up so high?
> 

You have some tasks that disable softirqs too long. Sometimes, bumping RX ring 
size is OK (but you will still have delays), sometimes it is not an option, 
since 4096 is the limit on current hardware.